package com.jot.judiciarymobile.activity;

import android.os.Bundle;

import com.google.android.material.bottomnavigation.BottomNavigationView;
import com.jot.judiciarymobile.R;
import com.jot.judiciarymobile.activity.ui.causeList.CaseCauseListFragment;
import com.jot.judiciarymobile.activity.ui.causeList.CauseListAssignmentFragment;
import com.jot.judiciarymobile.activity.ui.causeList.CauseListCourtFragment;
import com.jot.judiciarymobile.activity.ui.searchCase.CaseDetailsFragment;
import com.jot.judiciarymobile.activity.ui.searchCase.SearchCaseNumberFragment;
import com.jot.judiciarymobile.activity.ui.searchCase.SearchCaseRefFragment;
import com.jot.judiciarymobile.config.AppConfig;
import com.jot.judiciarymobile.config.Settings;

import androidx.appcompat.app.AppCompatActivity;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;
import androidx.navigation.NavController;
import androidx.navigation.Navigation;
import androidx.navigation.ui.AppBarConfiguration;
import androidx.navigation.ui.NavigationUI;

public class MainActivity extends AppCompatActivity implements SearchCaseNumberFragment.CaseNoInterface, SearchCaseRefFragment.CaseRefNoInterface, CauseListCourtFragment.CauseListCourtInterface, CauseListAssignmentFragment.CauseListJudgeInterface {

//    public class MainActivity extends AppCompatActivity implements CauseListCourtFragment.TestInterface {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        BottomNavigationView navView = findViewById(R.id.nav_view);
        // Passing each menu ID as a set of Ids because each
        // menu should be considered as top level destinations.
        AppBarConfiguration appBarConfiguration = new AppBarConfiguration.Builder(
                R.id.navigation_home , R.id.navigation_more,R.id.navigation_searchCase,R.id.navigation_causelist,R.id.navigation_CaseCauseListFragment)
                .build();
        NavController navController = Navigation.findNavController(this , R.id.nav_host_fragment);
        NavigationUI.setupActionBarWithNavController(this , navController , appBarConfiguration);
        NavigationUI.setupWithNavController(navView , navController);
    }

    @Override
    public void openCaseDetails(Bundle bundle) {

        Fragment fragment = new CaseDetailsFragment();
        FragmentManager fragmentManager = getSupportFragmentManager();
        FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
        fragment.setArguments(bundle);
        fragmentTransaction.replace(R.id.nav_host_fragment , fragment , fragment.getTag());
        fragmentTransaction.addToBackStack(null);
        fragmentTransaction.commit();
    }

    @Override
    public void openCauseList(Bundle bundle) {
        Fragment fragment = new CaseCauseListFragment();
        FragmentManager fragmentManager = getSupportFragmentManager();
        FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
        fragment.setArguments(bundle);
        fragmentTransaction.replace(R.id.nav_host_fragment , fragment, fragment.getTag());
        fragmentTransaction.addToBackStack(null);
        fragmentTransaction.commit();
    }



}