package com.jot.judiciarymobile.activity;


import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.widget.TextView;

import com.jot.judiciarymobile.R;
import com.jot.judiciarymobile.activity.ui.appintro.TourActivity;
import com.jot.judiciarymobile.config.AppConfig;

import java.util.Calendar;

public class SplashScreen extends Activity {

    TextView welcomeNote,InstituteName;

    //splash screen time
    private static int SPLASH_TIME_OUT = 1000;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_splashscreen);

        Calendar calendar = Calendar.getInstance();
        int year = calendar.get(Calendar.YEAR);

        welcomeNote = findViewById(R.id.welcomeNote);
        InstituteName = findViewById(R.id.InstituteName);

        welcomeNote.setText(getResources().getString(R.string.Welcome_note));
        InstituteName.setText(AppConfig.CopyWrite + " " + year + " "+getResources().getString(R.string.institute_name));

        new Handler().postDelayed(new Runnable() {

            /*
             * Showing splash screen with a timer. This will be useful when you
             * want to show case your app logo / company
             */

            @Override
            public void run() {
                // This method will be executed once the timer is over
                // Start your app main activity
                Intent i = new Intent(SplashScreen.this, TourActivity.class);
                startActivity(i);

                // close this activity
                finish();
            }
        }, SPLASH_TIME_OUT);
    }
}