package com.jot.judiciarymobile.activity.ui.causeList;

import android.app.DatePickerDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.ArrayAdapter;
import android.widget.AutoCompleteTextView;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonArrayRequest;
import com.jot.judiciarymobile.R;
import com.jot.judiciarymobile.config.AppConfig;
import com.jot.judiciarymobile.config.AppController;
import com.jot.judiciarymobile.config.InternetStatus;
import com.jot.judiciarymobile.config.Settings;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Locale;
import java.util.TimeZone;

public class CauseListCourtFragment extends Fragment {

    final Calendar calendar= Calendar.getInstance(TimeZone.getTimeZone("UTC"));

    private static final String TAG = CauseListCourtFragment.class.getSimpleName();

    EditText CauseListFrom,CauseListTo;
    AutoCompleteTextView CaseCourt;
    Button CauseListButton;
    ProgressDialog pDialog;
    CauseListCourtInterface mListener;


    DatePickerDialog.OnDateSetListener dateFrom,dateTo;

    public View onCreateView(@NonNull LayoutInflater inflater ,
                             ViewGroup container , Bundle savedInstanceState) {

        View root = inflater.inflate(R.layout.fragment_cause_list_court , container , false);
        getActivity().getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_VISIBLE| WindowManager.LayoutParams.SOFT_INPUT_ADJUST_RESIZE);


        CauseListFrom = root.findViewById(R.id.CauseListFrom);
        CauseListTo = root.findViewById(R.id.CauseListTo);
        CaseCourt = root.findViewById(R.id.CaseCourt);
        CauseListButton = root.findViewById(R.id.CourtCauseListButton);

        // Progress dialog
        pDialog = new ProgressDialog(getActivity());
        pDialog.setCancelable(false);

        dateFrom = new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear,
                                  int dayOfMonth) {
                // TODO Auto-generated method stub
                calendar.set(Calendar.YEAR, year);
                calendar.set(Calendar.MONTH, monthOfYear);
                calendar.set(Calendar.DAY_OF_MONTH, dayOfMonth);
                dateFrom();
            }

        };

        dateTo = new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear,
                                  int dayOfMonth) {
                // TODO Auto-generated method stub
                calendar.set(Calendar.YEAR, year);
                calendar.set(Calendar.MONTH, monthOfYear);
                calendar.set(Calendar.DAY_OF_MONTH, dayOfMonth);
                dateTo();
            }

        };

        CauseListFrom.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                // TODO Auto-generated method stub
                new DatePickerDialog(getActivity(), dateFrom, calendar
                        .get(Calendar.YEAR), calendar.get(Calendar.MONTH),
                        calendar.get(Calendar.DAY_OF_MONTH)).show();
            }
        });

        CauseListTo.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                // TODO Auto-generated method stub
                new DatePickerDialog(getActivity(), dateTo, calendar
                        .get(Calendar.YEAR), calendar.get(Calendar.MONTH),
                        calendar.get(Calendar.DAY_OF_MONTH)).show();
            }
        });


        if (InternetStatus.getInstance(getContext()).isOnline()) {

            CauseListButton.setOnClickListener(new View.OnClickListener() {
                public void onClick(View view) {

                    String date_from = CauseListFrom.getText().toString().trim();
                    String date_to = CauseListTo.getText().toString().trim();
                    String court_name = CaseCourt.getText().toString().trim();


                    if (!date_from.equals(getResources().getString(R.string.app_cause_list_from)) && !date_to.equals(getResources().getString(R.string.app_cause_list_to))
                            && !court_name.equals(getResources().getString(R.string.app_court))) {

                        if (!date_from.isEmpty() && !date_to.isEmpty() && !court_name.isEmpty()) {

                            Bundle bundle = new Bundle();
                            bundle.putString("court_name" , court_name);
                            bundle.putString("date_from" , date_from);
                            bundle.putString("date_to" , date_to);

                            mListener.openCauseList(bundle);

                            Settings.hideKeyboard(getActivity());

//                            Fragment fragment = new CaseCauseListFragment();
//                            FragmentManager fragmentManager = getParentFragmentManager();
//                            FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
//                            fragment.setArguments(bundle);
//                            fragmentTransaction.replace(R.id.nav_host_fragment , fragment);
//                            fragmentTransaction.addToBackStack(null);
//                            fragmentTransaction.commit();


                        }
                        else {
                            Toast.makeText(getActivity() ,
                                    (getResources().getString(R.string.app_search_fields)) , Toast.LENGTH_LONG).show();
                        }
                    }

                    if (date_from.equals(getResources().getString(R.string.app_cause_list_from)) || date_to.equals(getResources().getString(R.string.app_cause_list_to))
                            || court_name.equals(getResources().getString(R.string.app_court))) {
                        Toast.makeText(getActivity() ,
                                (getResources().getString(R.string.app_search_fields)) , Toast.LENGTH_LONG).show();
                    }
                }

            });


            getCourts();

        } // InternetLost Connection

        else {
            noConnection();
        }



        return root;
    }


    @Override
    public void onAttach(@NonNull Context context) {
        super.onAttach(context);
        if (context instanceof CauseListCourtInterface){
            mListener = (CauseListCourtInterface) context;
        }else{
            Log.d(CauseListCourtFragment.class.getSimpleName(), "Could not cast");
        }
    }

    private void getCourts(){

        final ArrayList<String> CourtList=new ArrayList<>();

        // Creating volley request obj
        JsonArrayRequest CourtData = new JsonArrayRequest(AppConfig.URL_GET_COURTS,
                new Response.Listener<JSONArray>() {

                    @Override
                    public void onResponse(JSONArray response) {
                        Log.d(TAG, response.toString());
                        hideDialog();

                        try {
                            for (int i = 0; i < response.length(); i++) {

                                JSONObject obj = response.getJSONObject(i);
                                String court_name = obj.getString("name");
                                CourtList.add(court_name);
                            }

                            ArrayAdapter<String> adapter = new ArrayAdapter<String>(getContext(), android.R.layout.select_dialog_item, CourtList);
                            CaseCourt.setAdapter(adapter);
                            hideDialog();

                        }catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                },
                new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {
                        //displaying the error in toast if occurrs
                        Toast.makeText(getActivity(), "Connection lost.. please reconnect", Toast.LENGTH_SHORT).show();
                    }
                });

        // request queue
        AppController.getInstance().addToRequestQueue(CourtData);
    }
    private void dateFrom() {
        String myFormat = "dd-MM-yyyy"; //In which you need put here
        SimpleDateFormat FromDate = new SimpleDateFormat(myFormat, Locale.ENGLISH);
        CauseListFrom.setText(FromDate.format(calendar.getTime()));
    }
    private void dateTo() {
        String myFormat = "dd-MM-yyyy"; //In which you need put here
        SimpleDateFormat ToDate = new SimpleDateFormat(myFormat, Locale.ENGLISH);
        CauseListTo.setText(ToDate.format(calendar.getTime()));
    }
    private void noConnection(){
        Toast.makeText(getActivity(), "Connection lost.. please reconnect", Toast.LENGTH_SHORT).show();
        CauseListButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Toast.makeText(getActivity(), "Connection lost.. please reconnect", Toast.LENGTH_SHORT).show();

            }
        });

    }
    private void noServerConnection(){
        Toast.makeText(getActivity(), "Oops! out of Service Try again later", Toast.LENGTH_SHORT).show();
        CauseListButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Toast.makeText(getActivity(), "Oops! out of Service Try again later", Toast.LENGTH_SHORT).show();

            }
        });

    }
    private void hideDialog() {
        if (pDialog.isShowing())
            pDialog.dismiss();
    }

    public interface CauseListCourtInterface{

        void openCauseList(Bundle bundle);
    }
}