package com.jot.judiciarymobile.activity.ui.home;

import android.app.AlertDialog;
import android.os.Bundle;
import android.os.Handler;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.cardview.widget.CardView;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;
import com.jot.judiciarymobile.R;
import com.jot.judiciarymobile.activity.ui.causeList.CauseListFragment;
import com.jot.judiciarymobile.activity.ui.courtfee.CourtFeeFragment;
import com.jot.judiciarymobile.activity.ui.events.EventsFragment;
import com.jot.judiciarymobile.activity.ui.searchCase.SearchCaseFragment;
import com.jot.judiciarymobile.activity.ui.scanner.ScannerFragment;


public class HomeFragment extends Fragment implements View.OnClickListener {

    TextView SearchCase,CauseList,CourtEvents,CourtJudgement,WelcomeMessage,BillScan,CourtFee;
    private CardView CardSearchCase,CardCauseList,CardCourtEvents,CardCourtJudgement,CardBillScan,CardCourtFee;
    ImageView imgNewCourtEvents;

    public View onCreateView(@NonNull LayoutInflater inflater ,
                             ViewGroup container , Bundle savedInstanceState) {

        View root = inflater.inflate(R.layout.fragment_home , container , false);
//        getActivity().setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);

        CardSearchCase = root.findViewById(R.id.CardSearchCase);
        CardCauseList = root.findViewById(R.id.CardCauseList);
        CardCourtFee= root.findViewById(R.id.CardCourtFee);
        CardCourtJudgement = root.findViewById(R.id.CardCourtJudgement);
//        CardBillScan = root.findViewById(R.id.CardBillScan);
//        CardCourtEvents = root.findViewById(R.id.CardCourtEvents);


        WelcomeMessage = root.findViewById(R.id.WelcomeMessage);
        SearchCase = root.findViewById(R.id.SearchCase);
        CauseList = root.findViewById(R.id.CauseList);
//        CourtEvents = root.findViewById(R.id.CourtEvents);
        CourtJudgement = root.findViewById(R.id.CourtJudgement);
//        BillScan = root.findViewById(R.id.BillScan);
        CourtFee = root.findViewById(R.id.CourtFee);

        WelcomeMessage.setText(getResources().getString(R.string.Welcome_note));
        SearchCase.setText(getResources().getString(R.string.search_case));
        CauseList.setText(getResources().getString(R.string.case_cause_list));
//        CourtEvents.setText(getResources().getString(R.string.app_feedback));
        CourtJudgement.setText(getResources().getString(R.string.search_judgement));
//        BillScan.setText(getResources().getString(R.string.app_bill_scan));
        CourtFee.setText(getResources().getString(R.string.app_feedback));

        
        CardCauseList.setOnClickListener(this);
//        CardCourtEvents.setOnClickListener(this);
        CardSearchCase.setOnClickListener(this);
        CardCourtJudgement.setOnClickListener(this);
//        CardBillScan.setOnClickListener(this);
        CardCourtFee.setOnClickListener(this);

//        blinkNewEvent();
        return root;

    }

    
    public void onClick(View view) {
        Fragment fragment;

        switch (view.getId()){

            case R.id.CardSearchCase :
                fragment = new SearchCaseFragment();
                FragmentManager fragmentManager = getParentFragmentManager();
                FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
                fragmentTransaction.replace(R.id.nav_host_fragment, fragment);
                fragmentTransaction.addToBackStack(null);
                fragmentTransaction.commit();
                break;


            case R.id.CardCauseList :

                fragment = new CauseListFragment();
                fragmentManager = getParentFragmentManager();
                fragmentTransaction = fragmentManager.beginTransaction();
                fragmentTransaction.replace(R.id.nav_host_fragment, fragment);
                fragmentTransaction.addToBackStack(null);
                fragmentTransaction.commit();
                break;

            case R.id.CardCourtJudgement :

                AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
                builder.setMessage("This Feature is coming soon..!")
                    .setNegativeButton(getResources().getString(R.string.app_button_dismiss), null);
                builder.show();


//                fragment = new CauseListFragment();
//                fragmentManager = getParentFragmentManager();
//                fragmentTransaction = fragmentManager.beginTransaction();
//                fragmentTransaction.replace(R.id.nav_host_fragment, fragment);
//                fragmentTransaction.commit();
//
                break;

            case R.id.CardCourtFee :

//                fragment = new CourtFeeFragment();
                fragment = new EventsFragment();
                fragmentManager = getParentFragmentManager();
                fragmentTransaction = fragmentManager.beginTransaction();
                fragmentTransaction.replace(R.id.nav_host_fragment, fragment);
                fragmentTransaction.addToBackStack(null);
                fragmentTransaction.commit();
                break;

//            case R.id.CardCourtEvents :
//
//                fragment = new EventsFragment();
//                fragmentManager = getParentFragmentManager();
//                fragmentTransaction = fragmentManager.beginTransaction();
//                fragmentTransaction.replace(R.id.nav_host_fragment, fragment);
//                fragmentTransaction.addToBackStack(null);
//                fragmentTransaction.commit();
//                break;

//            case R.id.CardBillScan :
//
//                fragment = new ScannerFragment();
//                fragmentManager = getParentFragmentManager();
//                fragmentTransaction = fragmentManager.beginTransaction();
//                fragmentTransaction.replace(R.id.nav_host_fragment, fragment);
//                fragmentTransaction.addToBackStack(null);
//                fragmentTransaction.commit();
//                break;

        }

    }

//    private void blinkNewEvent() {
//        final Handler handler = new Handler();
//        new Thread(new Runnable() {
//            @Override
//            public void run() {
//                int timeToBlink = 500;
//                try{Thread.sleep(timeToBlink);}catch (Exception e) {}
//                handler.post(new Runnable() {
//                    @Override
//                    public void run() {
////                        TextView txt = findViewById(R.id.text);
//                        if(imgNewCourtEvents.getVisibility()  == View.VISIBLE) {
//                            imgNewCourtEvents.setVisibility(View.INVISIBLE);
//                        } else {
//                            imgNewCourtEvents.setVisibility(View.VISIBLE);
//                        }
//                        blinkNewEvent();
//                    }
//                });
//            }
//        }).start();
//    }























}