package com.jot.judiciarymobile.activity.ui.more;

import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.text.Html;
import android.text.method.LinkMovementMethod;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;

import com.jot.judiciarymobile.R;
import com.jot.judiciarymobile.activity.ui.appintro.TourActivity;
import com.jot.judiciarymobile.activity.ui.appintro.WelcomeActivity;
import com.jot.judiciarymobile.config.AppConfig;

import java.util.Calendar;


public class MoreFragment extends Fragment implements View.OnClickListener{

    TextView AppVersion,Trademark,CallNumber,Mail,SMS,CheckUpdate,Tour;
    ImageView Website,Twitter,Facebook,Youtube,TourImg,CheckUpdateImg;



    public View onCreateView(@NonNull LayoutInflater inflater ,
                             ViewGroup container , Bundle savedInstanceState) {

        View root = inflater.inflate(R.layout.fragment_more , container , false);
//        getActivity().setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        Calendar calendar = Calendar.getInstance();
        int year = calendar.get(Calendar.YEAR);

        AppVersion = root.findViewById(R.id.AppVersion);
        Trademark = root.findViewById(R.id.Trademark);
        CallNumber = root.findViewById(R.id.CallNumber);
        Mail = root.findViewById(R.id.Mail);
        SMS = root.findViewById(R.id.SMS);
        CheckUpdate = root.findViewById(R.id.CheckUpdate);
        Tour = root.findViewById(R.id.Tour);

        Twitter = root.findViewById(R.id.Twitter);
        Facebook = root.findViewById(R.id.Facebook);
        Website = root.findViewById(R.id.Website);
        Youtube = root.findViewById(R.id.Youtube);
        TourImg = root.findViewById(R.id.TourImg);
        CheckUpdateImg = root.findViewById(R.id.CheckUpdateImg);

        AppVersion.setText("App Version: "+AppConfig.App_Version);
        Trademark.setText("\n"+AppConfig.CopyWrite+" "+year+" "+AppConfig.TradeMark);
        CallNumber.setText(AppConfig.call_center);
        Mail.setText(getResources().getString(R.string.mail));
        SMS.setText(AppConfig.sms);
        CheckUpdate.setText(getResources().getString(R.string.app_update));
        Tour.setText(getResources().getString(R.string.app_tour));

        Twitter.setOnClickListener(this);
        Facebook.setOnClickListener(this);
        Website.setOnClickListener(this);
        Youtube.setOnClickListener(this);
        Mail.setOnClickListener(this);
//        CallNumber.setOnClickListener(this);
//        SMS.setOnClickListener(this);
        Tour.setOnClickListener(this);
        TourImg.setOnClickListener(this);
        CheckUpdate.setOnClickListener(this);
        CheckUpdateImg.setOnClickListener(this);


        return root;
    }

    @Override
    public void onClick(View view) {

        Intent intent = new Intent();

        switch (view.getId()){

            case R.id.Twitter:
//                Toast.makeText(getActivity(), "Twitter", Toast.LENGTH_LONG).show();
                intent.setAction(Intent.ACTION_VIEW);
                intent.addCategory(Intent.CATEGORY_BROWSABLE);
                intent.setData(Uri.parse(AppConfig.twitter));
                startActivity(intent);
                break;

            case R.id.Facebook:
//                Toast.makeText(getActivity(), "Facebook", Toast.LENGTH_LONG).show();
                intent.setAction(Intent.ACTION_VIEW);
                intent.addCategory(Intent.CATEGORY_BROWSABLE);
                intent.setData(Uri.parse(AppConfig.facebook));
                startActivity(intent);
                break;

            case R.id.Website:
//                Toast.makeText(getActivity(), "Instagram", Toast.LENGTH_LONG).show();
                intent.setAction(Intent.ACTION_VIEW);
                intent.addCategory(Intent.CATEGORY_BROWSABLE);
                intent.setData(Uri.parse(AppConfig.website));
                startActivity(intent);
                break;

            case R.id.Youtube:
//                Toast.makeText(getActivity(), "Youtube", Toast.LENGTH_LONG).show();
                intent.setAction(Intent.ACTION_VIEW);
                intent.addCategory(Intent.CATEGORY_BROWSABLE);
                intent.setData(Uri.parse(AppConfig.youtube));
                startActivity(intent);
                break;

            case R.id.Mail:
//                Toast.makeText(getActivity(), "Youtube", Toast.LENGTH_LONG).show();
                intent.setAction(Intent.ACTION_VIEW);
                intent.addCategory(Intent.CATEGORY_BROWSABLE);
                intent.setData(Uri.parse(AppConfig.mail));
                startActivity(intent);
                break;

//            case R.id.CallNumber:
////                Toast.makeText(getActivity(), "Call Center", Toast.LENGTH_LONG).show();
//                Uri uri = Uri.parse("tel:"+AppConfig.call_center);
//                intent = new Intent(Intent.ACTION_DIAL, uri);
//                startActivity(intent);
//                break;

//            case R.id.SMS:
////                Toast.makeText(getActivity(), "Call Center", Toast.LENGTH_LONG).show();
//                uri = Uri.parse("smsto:" + AppConfig.sms);
//                intent = new Intent(Intent.ACTION_SENDTO, uri);
//                startActivity(intent);
//                break;

            case R.id.TourImg:
            case R.id.Tour:
                Intent tour = new Intent(getActivity(), WelcomeActivity.class);
                startActivity(tour);
                break;

            case R.id.CheckUpdateImg:
            case R.id.CheckUpdate:
                intent.setAction(Intent.ACTION_VIEW);
                intent.addCategory(Intent.CATEGORY_BROWSABLE);
                intent.setData(Uri.parse(AppConfig.CheckUpdate));
                startActivity(intent);
                break;


        }
    }
}