package com.jot.judiciarymobile.activity.ui.searchCase;



import android.os.Build;
import android.os.Bundle;

import androidx.annotation.RequiresApi;
import androidx.fragment.app.Fragment;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.jot.judiciarymobile.R;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.util.Date;

public class CaseDetailsFragment extends Fragment {

    TextView CaseTitle,CaseParties,CourtName,FilingDate,CaseRefNo,Status,Judge,Room,Stage,CaseDate,CaseMode,CaseModeDate;
    TextView StageLabel,DateLabel,CaseModeLabel,CaseModeDateLabel;
    View divider6,divider7_mode,divider3,divider4,divider5,divider2;
    String today_value_date;
    LinearLayout DateLinearPending,CaseModeLinear,CaseModeDateLinear,JudgeLinear,RoomLinear,OutcomeLinear;
    @RequiresApi(api = Build.VERSION_CODES.O)
    public View onCreateView(LayoutInflater inflater , ViewGroup container ,
                             Bundle savedInstanceState) {

        // Inflate the layout for this fragment
        View root =  inflater.inflate(R.layout.fragment_case_details , container , false);
        getActivity().getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);


        DateFormat outputFormat = new SimpleDateFormat("E, MMM dd yyyy");
        DateFormat inputFormat = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSX");
        DateFormat input = new SimpleDateFormat("yyyy-MM-dd");
        LocalDate Today = LocalDate.now();


        CaseTitle = root.findViewById(R.id.CaseTitle);
        CaseParties = root.findViewById(R.id.CaseParties);
        CourtName = root.findViewById(R.id.CourtName);
        FilingDate = root.findViewById(R.id.FilingDate);
        CaseRefNo = root.findViewById(R.id.CaseRefNo);
        Status = root.findViewById(R.id.Status);
        Judge = root.findViewById(R.id.Judge);
        Room = root.findViewById(R.id.Room);
        Stage = root.findViewById(R.id.Stage);
        CaseDate = root.findViewById(R.id.CaseDate);
        CaseMode = root.findViewById(R.id.CaseMode);
        CaseModeDate = root.findViewById(R.id.CaseModeDate);

        StageLabel = root.findViewById(R.id.StageLabel);
        DateLabel = root.findViewById(R.id.DateLabel);
        CaseModeLabel = root.findViewById(R.id.CaseModeLabel);
        CaseModeDateLabel = root.findViewById(R.id.CaseModeDateLabel);

        DateLinearPending = root.findViewById(R.id.DateLinearPending);
        CaseModeLinear = root.findViewById(R.id.CaseModeLinear);
        CaseModeDateLinear = root.findViewById(R.id.CaseModeDateLinear);
        JudgeLinear = root.findViewById(R.id.JudgeLinear);
        RoomLinear = root.findViewById(R.id.RoomLinear);
        OutcomeLinear = root.findViewById(R.id.OutcomeLinear);

        divider2 = root.findViewById(R.id.divider2);
        divider3 = root.findViewById(R.id.divider3);
        divider4 = root.findViewById(R.id.divider4);
        divider5 = root.findViewById(R.id.divider5);
        divider6 = root.findViewById(R.id.divider6);
        divider7_mode = root.findViewById(R.id.divider7_mode);


        String Case_Title = getArguments().getString("case_title");
        String Case_Parties = getArguments().getString("case_parties");
        String Court_Name = getArguments().getString("name");
        String Filing_Date = getArguments().getString("filing_date");
        String Case_Ref_No = getArguments().getString("case_ref_number");
        String Case_Status = getArguments().getString("proceeding_outcome");
        String Case_Judge = getArguments().getString("judge_name");
        String Court_Room = getArguments().getString("court_room_name");
        String Case_Stage = getArguments().getString("stage_name_or_last_order");
        String Case_Date = getArguments().getString("date_of_stage_or_determination");
        String Case_Determination = getArguments().getString("mode_of_determinatin");
        String Case_Outcome = getArguments().getString("case_outcome");
        today_value_date = String.valueOf(Today);

        Date date_filing = null;
        Date date_next = null;
        Date date_today = null;
        try {
            date_filing = inputFormat.parse(Filing_Date);
            date_next = inputFormat.parse(Case_Date);
            date_today = input.parse(today_value_date);

        } catch (ParseException e) {
            e.printStackTrace();
        }

        CaseTitle.setText(Case_Title);
        CaseParties.setText(Case_Parties);
        CourtName.setText(Court_Name);
        FilingDate.setText(outputFormat.format(date_filing));
        CaseRefNo.setText(Case_Ref_No);
        Status.setText(Case_Status);
        Judge.setText(Case_Judge);
        Room.setText(Court_Room);

        SimpleDateFormat dateOut = new SimpleDateFormat("yyyy-MM-dd");


//        if ( dateOut.format(date_today).compareTo(dateOut.format(date_next)) < 0) {
//
//            StageLabel.setText(getResources().getString(R.string.app_case_next_stage));
//            Stage.setText(Case_Stage);
//            CaseDate.setText(outputFormat.format(date_next));
//            CaseModeLinear.setVisibility(View.GONE);
//            CaseModeDateLinear.setVisibility(View.GONE);
//            divider7_mode.setVisibility(View.GONE);
//
//
//        }
//
//        if (dateOut.format(date_today).compareTo(dateOut.format(date_next)) > 0) {
//
//            CaseModeLabel.setText(getResources().getString(R.string.app_case_mode));
//            CaseModeDateLabel.setText(getResources().getString(R.string.app_date));
//            StageLabel.setText(getResources().getString(R.string.app_case_outcome));
//
//            CaseMode.setText(Case_Determination);
//            CaseModeDate.setText(outputFormat.format(date_next));
//            Stage.setText("   "+Case_Outcome);
//            DateLinearPending.setVisibility(View.GONE);
//            divider6.setVisibility(View.GONE);
//
//
//        }
//
//        if (dateOut.format(date_today).compareTo(dateOut.format(date_next)) == 0) {
//
//            StageLabel.setText(getResources().getString(R.string.app_case_next_stage));
//            Stage.setText(Case_Stage);
//            CaseDate.setText(outputFormat.format(date_next));
//            CaseModeLinear.setVisibility(View.GONE);
//            CaseModeDateLinear.setVisibility(View.GONE);
//            divider7_mode.setVisibility(View.GONE);
//
//        }

        if(Case_Status.compareTo("pending") == 0){

            StageLabel.setText(getResources().getString(R.string.app_case_next_stage));
            Stage.setText(Case_Stage);
            CaseDate.setText(outputFormat.format(date_next));
            CaseModeLinear.setVisibility(View.GONE);
            CaseModeDateLinear.setVisibility(View.GONE);
            divider7_mode.setVisibility(View.GONE);

        }

        if (Case_Status.compareTo("decided") == 0){

            CaseModeLabel.setText(getResources().getString(R.string.app_case_mode));
            CaseModeDateLabel.setText(getResources().getString(R.string.app_determination_date));
            StageLabel.setText(getResources().getString(R.string.app_case_outcome));

            CaseMode.setText(Case_Determination);
            CaseModeDate.setText(outputFormat.format(date_next));
            Stage.setText("   "+Case_Outcome);

            DateLinearPending.setVisibility(View.GONE);
            divider6.setVisibility(View.GONE);

        }

        if (Case_Status.compareTo("filed") == 0){

            DateLinearPending.setVisibility(View.GONE);
            CaseModeLinear.setVisibility(View.GONE);
            CaseModeDateLinear.setVisibility(View.GONE);
            JudgeLinear.setVisibility(View.GONE);
            RoomLinear.setVisibility(View.GONE);
            OutcomeLinear.setVisibility(View.GONE);

            divider2.setVisibility(View.GONE);
            divider3.setVisibility(View.GONE);
            divider4.setVisibility(View.GONE);
            divider5.setVisibility(View.GONE);
            divider6.setVisibility(View.GONE);
            divider7_mode.setVisibility(View.GONE);

        }

        return root;
    }
}